------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Header_View_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Header_View_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Header_Views is

   function cascadingSectionResizes_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, cascadingSectionResizes_0_wrapper,
                     "__Qt4Ada_QHeaderView_cascadingSectionResizes_0_wrapper");

   function count_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, count_0_wrapper,
                     "__Qt4Ada_QHeaderView_count_0_wrapper");

   function defaultAlignment_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Alignment;
   pragma Import (C, defaultAlignment_0_wrapper,
                     "__Qt4Ada_QHeaderView_defaultAlignment_0_wrapper");

   function defaultSectionSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, defaultSectionSize_0_wrapper,
                     "__Qt4Ada_QHeaderView_defaultSectionSize_0_wrapper");

   function hiddenSectionCount_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, hiddenSectionCount_0_wrapper,
                     "__Qt4Ada_QHeaderView_hiddenSectionCount_0_wrapper");

   procedure hideSection_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Logical_Index : Qt4.Q_Integer);
   pragma Import (C, hideSection_0_wrapper,
                     "__Qt4Ada_QHeaderView_hideSection_0_wrapper");

   function highlightSections_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, highlightSections_0_wrapper,
                     "__Qt4Ada_QHeaderView_highlightSections_0_wrapper");

   function isClickable_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isClickable_0_wrapper,
                     "__Qt4Ada_QHeaderView_isClickable_0_wrapper");

   function isMovable_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isMovable_0_wrapper,
                     "__Qt4Ada_QHeaderView_isMovable_0_wrapper");

   function isSectionHidden_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Logical_Index : Qt4.Q_Integer)
       return Qt4.bool;
   pragma Import (C, isSectionHidden_0_wrapper,
                     "__Qt4Ada_QHeaderView_isSectionHidden_0_wrapper");

   function isSortIndicatorShown_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isSortIndicatorShown_0_wrapper,
                     "__Qt4Ada_QHeaderView_isSortIndicatorShown_0_wrapper");

   function length_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, length_0_wrapper,
                     "__Qt4Ada_QHeaderView_length_0_wrapper");

   function logicalIndex_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Visual_Index : Qt4.Q_Integer)
       return Qt4.Q_Integer;
   pragma Import (C, logicalIndex_0_wrapper,
                     "__Qt4Ada_QHeaderView_logicalIndex_0_wrapper");

   function logicalIndexAt_2_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Position : Qt4.Q_Integer)
       return Qt4.Q_Integer;
   pragma Import (C, logicalIndexAt_2_wrapper,
                     "__Qt4Ada_QHeaderView_logicalIndexAt_2_wrapper");

   function logicalIndexAt_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer)
       return Qt4.Q_Integer;
   pragma Import (C, logicalIndexAt_1_wrapper,
                     "__Qt4Ada_QHeaderView_logicalIndexAt_1_wrapper");

   function logicalIndexAt_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : not null access constant Qt4.Points.Internals.QPoint)
       return Qt4.Q_Integer;
   pragma Import (C, logicalIndexAt_0_wrapper,
                     "__Qt4Ada_QHeaderView_logicalIndexAt_0_wrapper");

   function minimumSectionSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, minimumSectionSize_0_wrapper,
                     "__Qt4Ada_QHeaderView_minimumSectionSize_0_wrapper");

   procedure moveSection_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     From : Qt4.Q_Integer;
     To : Qt4.Q_Integer);
   pragma Import (C, moveSection_0_wrapper,
                     "__Qt4Ada_QHeaderView_moveSection_0_wrapper");

   function offset_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, offset_0_wrapper,
                     "__Qt4Ada_QHeaderView_offset_0_wrapper");

   function orientation_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Orientation;
   pragma Import (C, orientation_0_wrapper,
                     "__Qt4Ada_QHeaderView_orientation_0_wrapper");

   function resizeMode_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Logical_Index : Qt4.Q_Integer)
       return Qt4.Header_Views.Header_View_Resize_Mode;
   pragma Import (C, resizeMode_0_wrapper,
                     "__Qt4Ada_QHeaderView_resizeMode_0_wrapper");

   procedure resizeSection_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Logical_Index : Qt4.Q_Integer;
     Size : Qt4.Q_Integer);
   pragma Import (C, resizeSection_0_wrapper,
                     "__Qt4Ada_QHeaderView_resizeSection_0_wrapper");

   procedure resizeSections_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mode : Qt4.Header_Views.Header_View_Resize_Mode);
   pragma Import (C, resizeSections_0_wrapper,
                     "__Qt4Ada_QHeaderView_resizeSections_0_wrapper");

   function restoreState_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     State : not null access constant Qt4.Byte_Arrays.Internals.QByteArray)
       return Qt4.bool;
   pragma Import (C, restoreState_0_wrapper,
                     "__Qt4Ada_QHeaderView_restoreState_0_wrapper");

   procedure saveState_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Byte_Arrays.Internals.QByteArray);
   pragma Import (C, saveState_0_wrapper,
                     "__Qt4Ada_QHeaderView_saveState_0_wrapper");

   function sectionPosition_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Logical_Index : Qt4.Q_Integer)
       return Qt4.Q_Integer;
   pragma Import (C, sectionPosition_0_wrapper,
                     "__Qt4Ada_QHeaderView_sectionPosition_0_wrapper");

   function sectionSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Logical_Index : Qt4.Q_Integer)
       return Qt4.Q_Integer;
   pragma Import (C, sectionSize_0_wrapper,
                     "__Qt4Ada_QHeaderView_sectionSize_0_wrapper");

   function sectionSizeHint_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Logical_Index : Qt4.Q_Integer)
       return Qt4.Q_Integer;
   pragma Import (C, sectionSizeHint_0_wrapper,
                     "__Qt4Ada_QHeaderView_sectionSizeHint_0_wrapper");

   function sectionViewportPosition_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Logical_Index : Qt4.Q_Integer)
       return Qt4.Q_Integer;
   pragma Import (C, sectionViewportPosition_0_wrapper,
                     "__Qt4Ada_QHeaderView_sectionViewportPosition_0_wrapper");

   function sectionsHidden_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, sectionsHidden_0_wrapper,
                     "__Qt4Ada_QHeaderView_sectionsHidden_0_wrapper");

   function sectionsMoved_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, sectionsMoved_0_wrapper,
                     "__Qt4Ada_QHeaderView_sectionsMoved_0_wrapper");

   procedure setCascadingSectionResizes_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Enable : Qt4.bool);
   pragma Import (C, setCascadingSectionResizes_0_wrapper,
                     "__Qt4Ada_QHeaderView_setCascadingSectionResizes_0_wrapper");

   procedure setClickable_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Clickable : Qt4.bool);
   pragma Import (C, setClickable_0_wrapper,
                     "__Qt4Ada_QHeaderView_setClickable_0_wrapper");

   procedure setDefaultAlignment_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Alignment : Qt4.Alignment);
   pragma Import (C, setDefaultAlignment_0_wrapper,
                     "__Qt4Ada_QHeaderView_setDefaultAlignment_0_wrapper");

   procedure setDefaultSectionSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Size : Qt4.Q_Integer);
   pragma Import (C, setDefaultSectionSize_0_wrapper,
                     "__Qt4Ada_QHeaderView_setDefaultSectionSize_0_wrapper");

   procedure setHighlightSections_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Clickable : Qt4.bool);
   pragma Import (C, setHighlightSections_0_wrapper,
                     "__Qt4Ada_QHeaderView_setHighlightSections_0_wrapper");

   procedure setMinimumSectionSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Size : Qt4.Q_Integer);
   pragma Import (C, setMinimumSectionSize_0_wrapper,
                     "__Qt4Ada_QHeaderView_setMinimumSectionSize_0_wrapper");

   procedure setMovable_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Movable : Qt4.bool);
   pragma Import (C, setMovable_0_wrapper,
                     "__Qt4Ada_QHeaderView_setMovable_0_wrapper");

   procedure setResizeMode_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mode : Qt4.Header_Views.Header_View_Resize_Mode);
   pragma Import (C, setResizeMode_1_wrapper,
                     "__Qt4Ada_QHeaderView_setResizeMode_1_wrapper");

   procedure setResizeMode_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Logical_Index : Qt4.Q_Integer;
     Mode : Qt4.Header_Views.Header_View_Resize_Mode);
   pragma Import (C, setResizeMode_0_wrapper,
                     "__Qt4Ada_QHeaderView_setResizeMode_0_wrapper");

   procedure setSectionHidden_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Logical_Index : Qt4.Q_Integer;
     Hide : Qt4.bool);
   pragma Import (C, setSectionHidden_0_wrapper,
                     "__Qt4Ada_QHeaderView_setSectionHidden_0_wrapper");

   procedure setSortIndicator_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Logical_Index : Qt4.Q_Integer;
     Order : Qt4.Sort_Order);
   pragma Import (C, setSortIndicator_0_wrapper,
                     "__Qt4Ada_QHeaderView_setSortIndicator_0_wrapper");

   procedure setSortIndicatorShown_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Show : Qt4.bool);
   pragma Import (C, setSortIndicatorShown_0_wrapper,
                     "__Qt4Ada_QHeaderView_setSortIndicatorShown_0_wrapper");

   procedure setStretchLastSection_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Stretch : Qt4.bool);
   pragma Import (C, setStretchLastSection_0_wrapper,
                     "__Qt4Ada_QHeaderView_setStretchLastSection_0_wrapper");

   procedure showSection_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Logical_Index : Qt4.Q_Integer);
   pragma Import (C, showSection_0_wrapper,
                     "__Qt4Ada_QHeaderView_showSection_0_wrapper");

   function sortIndicatorOrder_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Sort_Order;
   pragma Import (C, sortIndicatorOrder_0_wrapper,
                     "__Qt4Ada_QHeaderView_sortIndicatorOrder_0_wrapper");

   function sortIndicatorSection_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, sortIndicatorSection_0_wrapper,
                     "__Qt4Ada_QHeaderView_sortIndicatorSection_0_wrapper");

   function stretchLastSection_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, stretchLastSection_0_wrapper,
                     "__Qt4Ada_QHeaderView_stretchLastSection_0_wrapper");

   function stretchSectionCount_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, stretchSectionCount_0_wrapper,
                     "__Qt4Ada_QHeaderView_stretchSectionCount_0_wrapper");

   procedure swapSections_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     First : Qt4.Q_Integer;
     Second : Qt4.Q_Integer);
   pragma Import (C, swapSections_0_wrapper,
                     "__Qt4Ada_QHeaderView_swapSections_0_wrapper");

   function visualIndex_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Logical_Index : Qt4.Q_Integer)
       return Qt4.Q_Integer;
   pragma Import (C, visualIndex_0_wrapper,
                     "__Qt4Ada_QHeaderView_visualIndex_0_wrapper");

   function visualIndexAt_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Position : Qt4.Q_Integer)
       return Qt4.Q_Integer;
   pragma Import (C, visualIndexAt_0_wrapper,
                     "__Qt4Ada_QHeaderView_visualIndexAt_0_wrapper");

   procedure headerDataChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Orientation : Qt4.Orientation;
     Logical_First : Qt4.Q_Integer;
     Logical_Last : Qt4.Q_Integer);
   pragma Import (C, headerDataChanged_0_wrapper,
                     "__Qt4Ada_QHeaderView_headerDataChanged_0_wrapper");

   procedure setOffset_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Offset : Qt4.Q_Integer);
   pragma Import (C, setOffset_0_wrapper,
                     "__Qt4Ada_QHeaderView_setOffset_0_wrapper");

   procedure setOffsetToLastSection_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setOffsetToLastSection_0_wrapper,
                     "__Qt4Ada_QHeaderView_setOffsetToLastSection_0_wrapper");

   procedure setOffsetToSectionPosition_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Visual_Index : Qt4.Q_Integer);
   pragma Import (C, setOffsetToSectionPosition_0_wrapper,
                     "__Qt4Ada_QHeaderView_setOffsetToSectionPosition_0_wrapper");

   pragma Style_Checks ("N");

   -------------------------------
   -- Cascading_Section_Resizes --
   -------------------------------

   function Cascading_Section_Resizes
    (Self : not null access constant Q_Header_View'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (cascadingSectionResizes_0_wrapper
           (Self.QObject_View));
   end Cascading_Section_Resizes;

   -----------
   -- Count --
   -----------

   function Count
    (Self : not null access constant Q_Header_View'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        count_0_wrapper
         (Self.QObject_View);
   end Count;

   -----------------------
   -- Default_Alignment --
   -----------------------

   function Default_Alignment
    (Self : not null access constant Q_Header_View'Class)
       return Qt4.Alignment
   is
   begin
      return
        defaultAlignment_0_wrapper
         (Self.QObject_View);
   end Default_Alignment;

   --------------------------
   -- Default_Section_Size --
   --------------------------

   function Default_Section_Size
    (Self : not null access constant Q_Header_View'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        defaultSectionSize_0_wrapper
         (Self.QObject_View);
   end Default_Section_Size;

   --------------------------
   -- Hidden_Section_Count --
   --------------------------

   function Hidden_Section_Count
    (Self : not null access constant Q_Header_View'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        hiddenSectionCount_0_wrapper
         (Self.QObject_View);
   end Hidden_Section_Count;

   ------------------
   -- Hide_Section --
   ------------------

   procedure Hide_Section
    (Self : not null access Q_Header_View'Class;
     Logical_Index : Qt4.Q_Integer)
   is
   begin
      hideSection_0_wrapper
       (Self.QObject_View,
        Logical_Index);
   end Hide_Section;

   ------------------------
   -- Highlight_Sections --
   ------------------------

   function Highlight_Sections
    (Self : not null access constant Q_Header_View'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (highlightSections_0_wrapper
           (Self.QObject_View));
   end Highlight_Sections;

   ------------------
   -- Is_Clickable --
   ------------------

   function Is_Clickable
    (Self : not null access constant Q_Header_View'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isClickable_0_wrapper
           (Self.QObject_View));
   end Is_Clickable;

   ----------------
   -- Is_Movable --
   ----------------

   function Is_Movable
    (Self : not null access constant Q_Header_View'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isMovable_0_wrapper
           (Self.QObject_View));
   end Is_Movable;

   -----------------------
   -- Is_Section_Hidden --
   -----------------------

   function Is_Section_Hidden
    (Self : not null access constant Q_Header_View'Class;
     Logical_Index : Qt4.Q_Integer)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isSectionHidden_0_wrapper
           (Self.QObject_View,
            Logical_Index));
   end Is_Section_Hidden;

   -----------------------------
   -- Is_Sort_Indicator_Shown --
   -----------------------------

   function Is_Sort_Indicator_Shown
    (Self : not null access constant Q_Header_View'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isSortIndicatorShown_0_wrapper
           (Self.QObject_View));
   end Is_Sort_Indicator_Shown;

   ------------
   -- Length --
   ------------

   function Length
    (Self : not null access constant Q_Header_View'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        length_0_wrapper
         (Self.QObject_View);
   end Length;

   -------------------
   -- Logical_Index --
   -------------------

   function Logical_Index
    (Self : not null access constant Q_Header_View'Class;
     Visual_Index : Qt4.Q_Integer)
       return Qt4.Q_Integer
   is
   begin
      return
        logicalIndex_0_wrapper
         (Self.QObject_View,
          Visual_Index);
   end Logical_Index;

   ----------------------
   -- Logical_Index_At --
   ----------------------

   function Logical_Index_At
    (Self : not null access constant Q_Header_View'Class;
     Position : Qt4.Q_Integer)
       return Qt4.Q_Integer
   is
   begin
      return
        logicalIndexAt_2_wrapper
         (Self.QObject_View,
          Position);
   end Logical_Index_At;

   ----------------------
   -- Logical_Index_At --
   ----------------------

   function Logical_Index_At
    (Self : not null access constant Q_Header_View'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer)
       return Qt4.Q_Integer
   is
   begin
      return
        logicalIndexAt_1_wrapper
         (Self.QObject_View,
          X,
          Y);
   end Logical_Index_At;

   ----------------------
   -- Logical_Index_At --
   ----------------------

   function Logical_Index_At
    (Self : not null access constant Q_Header_View'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Q_Integer
   is
   begin
      return
        logicalIndexAt_0_wrapper
         (Self.QObject_View,
          Qt4.Points.Internals.QPoint_View (Pos));
   end Logical_Index_At;

   --------------------------
   -- Minimum_Section_Size --
   --------------------------

   function Minimum_Section_Size
    (Self : not null access constant Q_Header_View'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        minimumSectionSize_0_wrapper
         (Self.QObject_View);
   end Minimum_Section_Size;

   ------------------
   -- Move_Section --
   ------------------

   procedure Move_Section
    (Self : not null access Q_Header_View'Class;
     From : Qt4.Q_Integer;
     To : Qt4.Q_Integer)
   is
   begin
      moveSection_0_wrapper
       (Self.QObject_View,
        From,
        To);
   end Move_Section;

   ------------
   -- Offset --
   ------------

   function Offset
    (Self : not null access constant Q_Header_View'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        offset_0_wrapper
         (Self.QObject_View);
   end Offset;

   -----------------
   -- Orientation --
   -----------------

   function Orientation
    (Self : not null access constant Q_Header_View'Class)
       return Qt4.Orientation
   is
   begin
      return
        orientation_0_wrapper
         (Self.QObject_View);
   end Orientation;

   -----------------
   -- Resize_Mode --
   -----------------

   function Resize_Mode
    (Self : not null access constant Q_Header_View'Class;
     Logical_Index : Qt4.Q_Integer)
       return Qt4.Header_Views.Header_View_Resize_Mode
   is
   begin
      return
        resizeMode_0_wrapper
         (Self.QObject_View,
          Logical_Index);
   end Resize_Mode;

   --------------------
   -- Resize_Section --
   --------------------

   procedure Resize_Section
    (Self : not null access Q_Header_View'Class;
     Logical_Index : Qt4.Q_Integer;
     Size : Qt4.Q_Integer)
   is
   begin
      resizeSection_0_wrapper
       (Self.QObject_View,
        Logical_Index,
        Size);
   end Resize_Section;

   ---------------------
   -- Resize_Sections --
   ---------------------

   procedure Resize_Sections
    (Self : not null access Q_Header_View'Class;
     Mode : Qt4.Header_Views.Header_View_Resize_Mode)
   is
   begin
      resizeSections_0_wrapper
       (Self.QObject_View,
        Mode);
   end Resize_Sections;

   -------------------
   -- Restore_State --
   -------------------

   function Restore_State
    (Self : not null access Q_Header_View'Class;
     State : Qt4.Byte_Arrays.Q_Byte_Array)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (restoreState_0_wrapper
           (Self.QObject_View,
            Qt4.Byte_Arrays.Internals.QByteArray_View (State)));
   end Restore_State;

   ----------------
   -- Save_State --
   ----------------

   function Save_State
    (Self : not null access constant Q_Header_View'Class)
       return Qt4.Byte_Arrays.Q_Byte_Array
   is
      Returns : Qt4.Byte_Arrays.Q_Byte_Array;

   begin
      saveState_0_wrapper
       (Self.QObject_View,
        Qt4.Byte_Arrays.Internals.QByteArray_View (Returns));

      return Returns;
   end Save_State;

   ----------------------
   -- Section_Position --
   ----------------------

   function Section_Position
    (Self : not null access constant Q_Header_View'Class;
     Logical_Index : Qt4.Q_Integer)
       return Qt4.Q_Integer
   is
   begin
      return
        sectionPosition_0_wrapper
         (Self.QObject_View,
          Logical_Index);
   end Section_Position;

   ------------------
   -- Section_Size --
   ------------------

   function Section_Size
    (Self : not null access constant Q_Header_View'Class;
     Logical_Index : Qt4.Q_Integer)
       return Qt4.Q_Integer
   is
   begin
      return
        sectionSize_0_wrapper
         (Self.QObject_View,
          Logical_Index);
   end Section_Size;

   -----------------------
   -- Section_Size_Hint --
   -----------------------

   function Section_Size_Hint
    (Self : not null access constant Q_Header_View'Class;
     Logical_Index : Qt4.Q_Integer)
       return Qt4.Q_Integer
   is
   begin
      return
        sectionSizeHint_0_wrapper
         (Self.QObject_View,
          Logical_Index);
   end Section_Size_Hint;

   -------------------------------
   -- Section_Viewport_Position --
   -------------------------------

   function Section_Viewport_Position
    (Self : not null access constant Q_Header_View'Class;
     Logical_Index : Qt4.Q_Integer)
       return Qt4.Q_Integer
   is
   begin
      return
        sectionViewportPosition_0_wrapper
         (Self.QObject_View,
          Logical_Index);
   end Section_Viewport_Position;

   ---------------------
   -- Sections_Hidden --
   ---------------------

   function Sections_Hidden
    (Self : not null access constant Q_Header_View'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (sectionsHidden_0_wrapper
           (Self.QObject_View));
   end Sections_Hidden;

   --------------------
   -- Sections_Moved --
   --------------------

   function Sections_Moved
    (Self : not null access constant Q_Header_View'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (sectionsMoved_0_wrapper
           (Self.QObject_View));
   end Sections_Moved;

   -----------------------------------
   -- Set_Cascading_Section_Resizes --
   -----------------------------------

   procedure Set_Cascading_Section_Resizes
    (Self : not null access Q_Header_View'Class;
     Enable : Standard.Boolean)
   is
   begin
      setCascadingSectionResizes_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Enable));
   end Set_Cascading_Section_Resizes;

   -------------------
   -- Set_Clickable --
   -------------------

   procedure Set_Clickable
    (Self : not null access Q_Header_View'Class;
     Clickable : Standard.Boolean)
   is
   begin
      setClickable_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Clickable));
   end Set_Clickable;

   ---------------------------
   -- Set_Default_Alignment --
   ---------------------------

   procedure Set_Default_Alignment
    (Self : not null access Q_Header_View'Class;
     Alignment : Qt4.Alignment)
   is
   begin
      setDefaultAlignment_0_wrapper
       (Self.QObject_View,
        Alignment);
   end Set_Default_Alignment;

   ------------------------------
   -- Set_Default_Section_Size --
   ------------------------------

   procedure Set_Default_Section_Size
    (Self : not null access Q_Header_View'Class;
     Size : Qt4.Q_Integer)
   is
   begin
      setDefaultSectionSize_0_wrapper
       (Self.QObject_View,
        Size);
   end Set_Default_Section_Size;

   ----------------------------
   -- Set_Highlight_Sections --
   ----------------------------

   procedure Set_Highlight_Sections
    (Self : not null access Q_Header_View'Class;
     Clickable : Standard.Boolean)
   is
   begin
      setHighlightSections_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Clickable));
   end Set_Highlight_Sections;

   ------------------------------
   -- Set_Minimum_Section_Size --
   ------------------------------

   procedure Set_Minimum_Section_Size
    (Self : not null access Q_Header_View'Class;
     Size : Qt4.Q_Integer)
   is
   begin
      setMinimumSectionSize_0_wrapper
       (Self.QObject_View,
        Size);
   end Set_Minimum_Section_Size;

   -----------------
   -- Set_Movable --
   -----------------

   procedure Set_Movable
    (Self : not null access Q_Header_View'Class;
     Movable : Standard.Boolean)
   is
   begin
      setMovable_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Movable));
   end Set_Movable;

   ---------------------
   -- Set_Resize_Mode --
   ---------------------

   procedure Set_Resize_Mode
    (Self : not null access Q_Header_View'Class;
     Mode : Qt4.Header_Views.Header_View_Resize_Mode)
   is
   begin
      setResizeMode_1_wrapper
       (Self.QObject_View,
        Mode);
   end Set_Resize_Mode;

   ---------------------
   -- Set_Resize_Mode --
   ---------------------

   procedure Set_Resize_Mode
    (Self : not null access Q_Header_View'Class;
     Logical_Index : Qt4.Q_Integer;
     Mode : Qt4.Header_Views.Header_View_Resize_Mode)
   is
   begin
      setResizeMode_0_wrapper
       (Self.QObject_View,
        Logical_Index,
        Mode);
   end Set_Resize_Mode;

   ------------------------
   -- Set_Section_Hidden --
   ------------------------

   procedure Set_Section_Hidden
    (Self : not null access Q_Header_View'Class;
     Logical_Index : Qt4.Q_Integer;
     Hide : Standard.Boolean)
   is
   begin
      setSectionHidden_0_wrapper
       (Self.QObject_View,
        Logical_Index,
        Qt4.To_bool (Hide));
   end Set_Section_Hidden;

   ------------------------
   -- Set_Sort_Indicator --
   ------------------------

   procedure Set_Sort_Indicator
    (Self : not null access Q_Header_View'Class;
     Logical_Index : Qt4.Q_Integer;
     Order : Qt4.Sort_Order)
   is
   begin
      setSortIndicator_0_wrapper
       (Self.QObject_View,
        Logical_Index,
        Order);
   end Set_Sort_Indicator;

   ------------------------------
   -- Set_Sort_Indicator_Shown --
   ------------------------------

   procedure Set_Sort_Indicator_Shown
    (Self : not null access Q_Header_View'Class;
     Show : Standard.Boolean)
   is
   begin
      setSortIndicatorShown_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Show));
   end Set_Sort_Indicator_Shown;

   ------------------------------
   -- Set_Stretch_Last_Section --
   ------------------------------

   procedure Set_Stretch_Last_Section
    (Self : not null access Q_Header_View'Class;
     Stretch : Standard.Boolean)
   is
   begin
      setStretchLastSection_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Stretch));
   end Set_Stretch_Last_Section;

   ------------------
   -- Show_Section --
   ------------------

   procedure Show_Section
    (Self : not null access Q_Header_View'Class;
     Logical_Index : Qt4.Q_Integer)
   is
   begin
      showSection_0_wrapper
       (Self.QObject_View,
        Logical_Index);
   end Show_Section;

   --------------------------
   -- Sort_Indicator_Order --
   --------------------------

   function Sort_Indicator_Order
    (Self : not null access constant Q_Header_View'Class)
       return Qt4.Sort_Order
   is
   begin
      return
        sortIndicatorOrder_0_wrapper
         (Self.QObject_View);
   end Sort_Indicator_Order;

   ----------------------------
   -- Sort_Indicator_Section --
   ----------------------------

   function Sort_Indicator_Section
    (Self : not null access constant Q_Header_View'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        sortIndicatorSection_0_wrapper
         (Self.QObject_View);
   end Sort_Indicator_Section;

   --------------------------
   -- Stretch_Last_Section --
   --------------------------

   function Stretch_Last_Section
    (Self : not null access constant Q_Header_View'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (stretchLastSection_0_wrapper
           (Self.QObject_View));
   end Stretch_Last_Section;

   ---------------------------
   -- Stretch_Section_Count --
   ---------------------------

   function Stretch_Section_Count
    (Self : not null access constant Q_Header_View'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        stretchSectionCount_0_wrapper
         (Self.QObject_View);
   end Stretch_Section_Count;

   -------------------
   -- Swap_Sections --
   -------------------

   procedure Swap_Sections
    (Self : not null access Q_Header_View'Class;
     First : Qt4.Q_Integer;
     Second : Qt4.Q_Integer)
   is
   begin
      swapSections_0_wrapper
       (Self.QObject_View,
        First,
        Second);
   end Swap_Sections;

   ------------------
   -- Visual_Index --
   ------------------

   function Visual_Index
    (Self : not null access constant Q_Header_View'Class;
     Logical_Index : Qt4.Q_Integer)
       return Qt4.Q_Integer
   is
   begin
      return
        visualIndex_0_wrapper
         (Self.QObject_View,
          Logical_Index);
   end Visual_Index;

   ---------------------
   -- Visual_Index_At --
   ---------------------

   function Visual_Index_At
    (Self : not null access constant Q_Header_View'Class;
     Position : Qt4.Q_Integer)
       return Qt4.Q_Integer
   is
   begin
      return
        visualIndexAt_0_wrapper
         (Self.QObject_View,
          Position);
   end Visual_Index_At;

   -------------------------
   -- Header_Data_Changed --
   -------------------------

   procedure Header_Data_Changed
    (Self : not null access Q_Header_View'Class;
     Orientation : Qt4.Orientation;
     Logical_First : Qt4.Q_Integer;
     Logical_Last : Qt4.Q_Integer)
   is
   begin
      headerDataChanged_0_wrapper
       (Self.QObject_View,
        Orientation,
        Logical_First,
        Logical_Last);
   end Header_Data_Changed;

   ----------------
   -- Set_Offset --
   ----------------

   procedure Set_Offset
    (Self : not null access Q_Header_View'Class;
     Offset : Qt4.Q_Integer)
   is
   begin
      setOffset_0_wrapper
       (Self.QObject_View,
        Offset);
   end Set_Offset;

   --------------------------------
   -- Set_Offset_To_Last_Section --
   --------------------------------

   procedure Set_Offset_To_Last_Section
    (Self : not null access Q_Header_View'Class)
   is
   begin
      setOffsetToLastSection_0_wrapper
       (Self.QObject_View);
   end Set_Offset_To_Last_Section;

   ------------------------------------
   -- Set_Offset_To_Section_Position --
   ------------------------------------

   procedure Set_Offset_To_Section_Position
    (Self : not null access Q_Header_View'Class;
     Visual_Index : Qt4.Q_Integer)
   is
   begin
      setOffsetToSectionPosition_0_wrapper
       (Self.QObject_View,
        Visual_Index);
   end Set_Offset_To_Section_Position;

end Qt4.Header_Views;
